unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Ustawienia: TButton;
    SaveDialog1: TSaveDialog;
    Zapisz: TSpeedButton;
    RichEdit1: TRichEdit;
    Timer1: TTimer;
    Button1: TButton;
    Timer2: TTimer;
    Button2: TButton;
    Label1: TLabel;
    RichEdit2: TRichEdit;
    RichEdit3: TRichEdit;
    L_R19: TLabel;
    L_R20: TLabel;
    L_R21: TLabel;
    Label2: TLabel;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure UstawieniaClick(Sender: TObject);
    procedure ZapiszClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure Write_Comm(hCommDev: THANDLE; nNumberOfBytesToWrite: DWORD);
    procedure Read_Comm(hCommDev: THANDLE; Buf_Size: DWORD);
    procedure Odczytaj_ini();
  public
    { Public declarations }
    procedure OtworzPort();
    procedure Wstaw_strzalke();
  end;

var
  Form1: TForm1;
  Com:Byte;               //Ktry port
  SciezkaPliku:String[255];


implementation

uses Unit2;

{$R *.dfm}

const
// -- wartoci flag sterujcych portu szeregowego --
  dcb_fBinary = $0001;
  dcb_fParity = $0002;
  dcb_fOutxCtsFlow = $0004;
  dcb_fOutxDsrFlow = $0008;

  // -- fDtrControl --
  DTR_CONTROL_ENABLE = $0010;
  DTR_CONTROL_HANDSHAKE = $0020;

  dcb_fDsrSensitivity = $0040;
  dcb_fTXContinueOnXoff = $0080;
  dcb_fOutX = $0100;
  dcb_fInX  = $0200;
  dcb_fErrorChar = $0400;
  dcb_fNull = $0800;

  // -- fRtsControl --
  RTS_CONTROL_ENABLE = $1000;
  RTS_CONTROL_HANDSHAKE = $2000;
  RTS_CONTROL_TOGGLE = $3000;

  dcb_fAbortOnError = $4000;

  cbInQueue = 2048;
  cbOutQueue = 16;


  Lookup_Table:Array[$0060..$00FF] of Word =
  (0, 0, 0, 0, 0, 1, 4, 10, 16, 17,
  22, 23, 27, 28, 29, 32, 33, 38, 39, 43,
  44, 45, 49, 50, 55, 56, 60, 61, 62, 65,
  66, 71, 72, 76, 77, 78, 81, 82, 87, 88,
  92, 93, 94, 97, 98, 103, 104, 108, 109, 110,
  113, 114, 119, 120, 124, 125, 126, 129, 130, 135,
  136, 140, 143, 144, 149, 150, 154, 155, 158, 160,
  161, 164, 165, 174, 175, 180, 181, 185, 186, 187,
  191, 0, 192, 193, 196, 197, 202, 203, 207, 208,
  209, 214, 215, 217, 219, 220, 222, 227, 231, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0);


var
  Buffer_O:ARRAY[0..cbOutQueue] of Byte; // bufor wyjciowy
  Buffer_I:ARRAY[0..cbInQueue] of Byte;  // bufor wejciowy
  Number_Bytes_Read:DWORD;
  hCommDev:THANDLE;
  lpFileName:PChar;
  fdwEvtMask:DWORD;
  Stat:TCOMSTAT;
  Errors:DWORD;
  dcb:TDCB;

  Plik:File;
  Buffer:Array[0..2047] of Byte;
  Rozmiar:DWord;

  PC:Word;

//--------------------------------------------------------------------
procedure TForm1.Write_Comm(hCommDev: THANDLE; nNumberOfBytesToWrite: DWORD);
var
  NumberOfBytesWritten : DWORD;
begin
  WriteFile(hCommDev, Buffer_O, nNumberOfBytesToWrite, NumberOfBytesWritten, NIL);
  WaitCommEvent(hCommDev, fdwEvtMask, Nil);
end;
//-----------------------------------------------------------
procedure TForm1.Read_Comm(hCommDev: THANDLE; Buf_Size: DWORD);
var
  nNumberOfBytesToRead:DWORD;
begin
  ClearCommError(hCommDev, Errors, @Stat);
  If (Stat.cbInQue > 0) then
    begin
      If (Stat.cbInQue > Buf_Size) then
        nNumberOfBytesToRead:=Buf_Size
      else
        nNumberOfBytesToRead:=Stat.cbInQue;

      ReadFile(hCommDev, Buffer_I, nNumberOfBytesToRead,
        Number_Bytes_Read, NIL);
    end
  else
    Number_Bytes_Read:=0;
end;
//-----------------------------------------------------------
procedure TForm1.OtworzPort();
begin
  CloseHandle(hCommDev);  //----Zamyka port eby mona byo go
                          //----otwoyc z nowymi ustawieniami

  lpFileName:=PChar('COM' + IntToStr(Com));

  hCommDev:=CreateFile(lpFileName, GENERIC_READ or GENERIC_WRITE,0,
                         NIL, OPEN_EXISTING, 0, 0);

  If (hCommDev <> INVALID_HANDLE_VALUE) then
    begin
      SetupComm(hCommDev, cbInQueue, cbOutQueue);
      dcb.DCBlength:=sizeof(dcb);
      GetCommState(hCommDev, dcb);

      dcb.BaudRate:=CBR_19200;
      //-- przykadowe ustawienia znacznikw sterujcych DCB --
      dcb.Flags:=RTS_CONTROL_ENABLE or DTR_CONTROL_ENABLE or dcb_fParity;
      dcb.Parity:=ODDPARITY;
      dcb.StopBits:=TWOSTOPBITS;
      dcb.ByteSize:=8;

      SetCommState(hCommDev, dcb);
      GetCommMask(hCommDev, fdwEvtMask);
      SetCommMask(hCommDev, EV_TXEMPTY);
    end
  Else
    If hCommDev = IE_BADID Then
      MessageDlg('Niewaciwa nazwa portu ' + lpFileName + ' lub jest on aktywny ', mtError, [mbOk], 0);
end;
//-----------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CloseHandle(hCommDev);
end;
//-----------------------------------------------------------
procedure TForm1.UstawieniaClick(Sender: TObject);
begin
  Odczytaj_ini();

  FormUstaw.CBCom.ItemIndex:=Com - 1;

  FormUstaw.Show;
end;
//-----------------------------------------------------------
procedure TForm1.ZapiszClick(Sender: TObject);
begin
  If SaveDialog1.Execute Then
    RichEdit1.Lines.SaveToFile(SaveDialog1.FileName + '.rtf');
end;
//-----------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
var
  i:Integer;
begin
  Read_Comm(hCommDev, SizeOf(Buffer_I));

  For i:=0 to Number_Bytes_Read-1 do
    Buffer[Rozmiar+i]:=Byte(Buffer_I[i]);

  Rozmiar:=Rozmiar + Number_Bytes_Read;
end;
//-----------------------------------------------------------
procedure TForm1.Odczytaj_ini();
var
  ini:TextFile;
  Data:Byte;
begin
  AssignFile(ini, SciezkaPliku);
  Reset(ini);

  Readln(ini, Com);

  CloseFile(ini);
end;
//-----------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  SciezkaPliku:=ExtractFilePath(Application.ExeName) + 'Config.ini';
  Odczytaj_ini();

  OtworzPort();
end;
//-----------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
var
  i:Integer;
begin
  Buffer_O[0]:=23;
  Write_Comm(hCommDev, 1);

  Read_Comm(hCommDev, SizeOf(Buffer_I));
  Rozmiar:=0;

  For i:=0 to 2047 do
    Buffer[i]:=0;

  Timer2.Tag:=0;
  Timer2.Enabled:=True;
end;
//-----------------------------------------------------------
procedure TForm1.Timer2Timer(Sender: TObject);
var
  i:Integer;
  Data:Byte;
begin
  If Timer2.Tag = 0 Then
    begin
      Timer1.Enabled:=True;
    end;


  If Timer2.Tag >= 1 Then
    begin
      Timer1.Enabled:=False;

      Timer2.Enabled:=False;




      RichEdit1.Text:='';
      i:=0;
      While i < 1020 do
        begin
          Data:=Buffer[i] And $F0;

          Case Data of
            $00:begin
                  RichEdit1.Lines.Add('Nothing');
                end;
            $10:begin
                  RichEdit1.Lines.Add('I2C Start');
                end;
            $20:begin
                  RichEdit1.Lines.Add('I2C Stop');
                end;
            $40:begin
                   Data:=(Buffer[i+1] And $FE) + (Buffer[i] And $01);

                   If Buffer[i] And $04 = 0 Then
                     RichEdit1.Lines.Add('I2C &H' + IntToHex(Data, 2) + ' Ack')
                   Else
                     RichEdit1.Lines.Add('I2C &H' + IntToHex(Data, 2) + ' Nack');


                   i:=i + 1;
                end;
            $80:begin
                  RichEdit1.Lines.Add('Buffer Full');
                end;
          end;

          i:=i + 1;
        end;


        PC:=Buffer[1020]*256 + Buffer[1021];
        Wstaw_strzalke();
        //RichEdit1.Lines.Add(IntToStr(Buffer[i]) + ' ' + IntToStr(Buffer[i+1]));


        L_R19.Caption:='R19 = ' + IntToStr(Buffer[1022]);
        L_R20.Caption:='R20 = ' + IntToStr(Buffer[1023]);
        L_R21.Caption:='R21 = ' + IntToStr(Buffer[1024]);



        Data:=45;
        For i:=0 to 1024 do
          Data:=Data + Buffer[i];

        i:=Buffer[1025];

        If Data = Buffer[1025] then
          begin
            Label2.Caption:='CRC Ok';
            Label2.Font.Color:=RGB(0, 200, 0);
          end
        Else
          begin
            Label2.Caption:='CRC Error';
            Label2.Font.Color:=RGB(255, 0, 0);
          end;
    end;




  Timer2.Tag:=Timer2.Tag + 1;
end;
//-----------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
begin
  Buffer_O[0]:=$55;
  Write_Comm(hCommDev, 1);
end;
//-----------------------------------------------------------
procedure TForm1.Wstaw_strzalke();
var
  i:Word;
  Nr_linii:Word;
begin
  If (PC >= 96) And (PC <= 227) Then
    begin
      Nr_Linii:=Lookup_Table[PC];

      For i:=0 to 231 do
        begin
          If i <> Nr_Linii Then
            RichEdit2.Lines.Strings[i]:=RichEdit3.Lines.Strings[i];
        end;


      RichEdit2.Lines.Strings[Nr_Linii]:='-->' + Copy(RichEdit3.Lines.Strings[Nr_Linii], 5, Length(RichEdit3.Lines.Strings[Nr_Linii])-4);

      RichEdit2.SelStart:=RichEdit2.Perform(EM_LINEINDEX, Nr_Linii, 0);
      RichEdit2.SelLength:=0;
      RichEdit2.Perform(EM_SCROLLCARET, 0, 0);
      RichEdit2.SetFocus();



      Label1.Caption:='PC = ' + IntToStr(PC);
    end
  Else
    begin
      For i:=0 to 231 do
        RichEdit2.Lines.Strings[i]:=RichEdit3.Lines.Strings[i];

      Label1.Caption:='PC = ' + IntToStr(PC) + '  (Nieobsugiwana warto)';
    end;
end;
//-----------------------------------------------------------
end.











